'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var glob = require('glob'),
    TSLint = require('tslint'),
    ReporterType = require('../reporter.enum'),
    Reporter = require('../reporter');

module.exports = function (_Reporter) {
  _inherits(TSLintReporter, _Reporter);

  function TSLintReporter(options, projectName) {
    _classCallCheck(this, TSLintReporter);

    var _this = _possibleConstructorReturn(this, (TSLintReporter.__proto__ || Object.getPrototypeOf(TSLintReporter)).call(this, options, projectName));

    _this.linterName = 'TSLint';
    return _this;
  }

  _createClass(TSLintReporter, [{
    key: 'launch',
    value: function launch(done) {
      var _this2 = this;

      glob(this.options.src, function (er, files) {
        _this2.processFiles(files);
        _this2.closeReporter(_this2.options.report);

        if (typeof done === 'function') {
          done();
        }
      });
    }
  }, {
    key: 'processFiles',
    value: function processFiles(fileArray) {
      var _this3 = this;

      this.openReporter();
      fileArray.forEach(function (file) {
        _this3.processFile(file);
      });
    }
  }, {
    key: 'processFile',
    value: function processFile(file) {
      var input = this.readFile(file),
          tslint = new TSLint.Linter({ formatter: 'prose' }, undefined);

      var configuration = TSLint.Configuration.findConfiguration(this.options.rulesFile || null, file).results;
      tslint.lint(file, input, configuration);

      this.openFileIssues(file, null, /^(\s+)?\n$/gm);
      var result = tslint.getResult();
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = result.failures[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var message = _step.value;

          this.addIssue(message.startPosition.lineAndCharacter.line + 1, message.failure, message.failure, message.ruleName, this.INFO, ReporterType.TSLINT);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }], [{
    key: 'defaultOptions',
    value: function defaultOptions() {
      return {
        src: 'src/**/*.js',
        report: 'reports/sonar/tslint.json',
        rulesFile: 'tslint.json'
      };
    }
  }]);

  return TSLintReporter;
}(Reporter);